<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/feedforward neural network/model/inc/ffNet.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('ff_net_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">ffNet.h</div></div>
</div><!--header-->
<div class="contents">
<a href="ff_net_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">*  @file ffNet.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">*  @brief File containing declaration of the FeedForwardNet class.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;vector&gt;</span>       <span class="comment">// std::vector       a</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;cmath&gt;</span>        <span class="comment">// std::tanh</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;algorithm&gt;</span>    <span class="comment">// std::min, std::max, std::transform</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;string&gt;</span>       <span class="comment">// std::string, std::to_string</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span><span class="preprocessor">#include &lt;utility&gt;</span>      <span class="comment">// std::pair, std::make_pair</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#include &lt;memory&gt;</span>       <span class="comment">// std::shared_ptr, std::make_shared</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#include &quot;<a class="code" href="vectorarithmetics_8h.html">vectorarithmetics.h</a>&quot;</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span><span class="preprocessor">#include &quot;<a class="code" href="exceptions_8h.html">exceptions.h</a>&quot;</span></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#include &quot;<a class="code" href="_me_l_on_8h.html">MeLOn.h</a>&quot;</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span><span class="preprocessor">#include &quot;<a class="code" href="_ann_properties_8h.html">AnnProperties.h</a>&quot;</span></div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="preprocessor">#include &quot;<a class="code" href="_ann_parser_8h.html">AnnParser.h</a>&quot;</span></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="foldopen" id="foldopen00037" data-start="{" data-end="};">
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">   37</a></span>    <span class="keyword">enum</span> <a class="code hl_enumeration" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a> {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06">   38</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06">TANH_REF_0</a> = 0,     </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44">   39</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44">TANH_REF1</a>,          </div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42">   40</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42">TANH_REF2</a>,          </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e">   41</a></span>        <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e">TANH_REF3</a>,          </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0">TANH_REF4</a>           </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno"><a class="line" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0">   43</a></span>    };</div>
</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00052" data-start="{" data-end="};">
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html">   52</a></span>    <span class="keyword">class </span><a class="code hl_class" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a> : <span class="keyword">public</span> <a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel</a>&lt;T&gt; {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <span class="keyword">private</span>:</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a3b6e46ca8afad6af62b3f15e2b6b5ec6">   55</a></span>        std::shared_ptr&lt;const AnnData&gt; <a class="code hl_variable" href="classmelon_1_1_feed_forward_net.html#a3b6e46ca8afad6af62b3f15e2b6b5ec6">_annData</a>;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a8d22eb1e65b7f74b4e84c3c8ea78df51">   57</a></span>        std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_variable" href="classmelon_1_1_feed_forward_net.html#a8d22eb1e65b7f74b4e84c3c8ea78df51">_inputScaler</a>;            </div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a25f7c656e140792b73fccc7058249256">   58</a></span>        std::unique_ptr&lt;Scaler&lt;T&gt;&gt; <a class="code hl_variable" href="classmelon_1_1_feed_forward_net.html#a25f7c656e140792b73fccc7058249256">_outputScaler</a>;           </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#aa29c58f20ab3b344243565940fc0e243">   61</a></span>        T(*<a class="code hl_variable" href="classmelon_1_1_feed_forward_net.html#aa29c58f20ab3b344243565940fc0e243">_tanh_formulation</a>) (T) = &amp;<a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#acc52bba26e3affaf5bd8bdd97367130f">_tanh</a>;                                                                                  </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#acc52bba26e3affaf5bd8bdd97367130f">   62</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#acc52bba26e3affaf5bd8bdd97367130f">_tanh</a>(T x) { <span class="keyword">using </span>std::tanh;  <span class="keywordflow">return</span> tanh(x); }</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#aa827bc95b61702119170c403edb86f9c">   63</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#aa827bc95b61702119170c403edb86f9c">_tanh_reformulation_1</a>(T x) { <span class="keywordflow">return</span> (exp(x) - exp(-1 * x)) / (exp(x) + exp(-1 * x)); }</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#af2ce30b35e0450243cdcc4f77649b9a7">   64</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#af2ce30b35e0450243cdcc4f77649b9a7">_tanh_reformulation_2</a>(T x) { <span class="keywordflow">return</span> (exp(2 * x) - 1) / (exp(2 * x) + 1); }</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#aa135bf5d528c1b99a63f0cf3ddceb7ac">   65</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#aa135bf5d528c1b99a63f0cf3ddceb7ac">_tanh_reformulation_3</a>(T x) { <span class="keywordflow">return</span> 1 - 2 / (1 + exp(2 * x)); }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#ac33420287de3773a2ab4dfab022287cf">   66</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#ac33420287de3773a2ab4dfab022287cf">_tanh_reformulation_4</a>(T x) { <span class="keywordflow">return</span> (1 - exp(-2 * x)) / (1 + exp(-2 * x)); }</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        </div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a81e55a0f8f437563f86d3e896c1db9c0">   68</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a81e55a0f8f437563f86d3e896c1db9c0">_relu</a>(T x) { <span class="keyword">using </span>std::max; <span class="keywordflow">return</span> max((T)0, x); }</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#ab7ba2a702f03f392778f7d05a43ce356">   69</a></span>        <span class="keyword">inline</span> <span class="keyword">static</span> T <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#ab7ba2a702f03f392778f7d05a43ce356">_relu6</a>(T x) { <span class="keyword">using </span>std::max; <span class="keyword">using </span>std::min; <span class="keywordflow">return</span> min((T)6, max((T)0, x)); }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>      </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a52bc8b4239937c6290e3a2b59dad9f24">_calculate_layer_activation</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v, <span class="keyword">const</span> <a class="code hl_enumeration" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a> activationFunction);</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a863db6c1f3e0937db86ecbb59cacf635">_calculate_prediction</a>(<span class="keyword">const</span> std::vector&lt;T&gt; input, <span class="keyword">const</span> std::vector&lt;T&gt; internalVariables, <span class="keyword">const</span> <span class="keywordtype">bool</span> fullSpace, std::vector&lt;T&gt;&amp; constraints);</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#ae98f7e952148f9d8aa22d2450f50f9db">_set_data_object</a>(std::shared_ptr&lt;const ModelData&gt; modelData) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span> </div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>    <span class="keyword">public</span>:</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a40d5999e0803420f02e2285aee4d7f19">  110</a></span>        <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a40d5999e0803420f02e2285aee4d7f19">FeedForwardNet</a>() : <a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel</a>&lt;T&gt;(std::make_shared&lt;<a class="code hl_class" href="classmelon_1_1_ann_parser_factory.html">AnnParserFactory</a>&gt;()) {};</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#ac1ac26b7d389470fc0a13463cddd9a3f">  119</a></span>        <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#ac1ac26b7d389470fc0a13463cddd9a3f">FeedForwardNet</a>(std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType) : <a class="code hl_class" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelName, fileType); };</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span> </div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#aa5bfb8592ff40db349c0699f22dcaf6e">  130</a></span>        <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#aa5bfb8592ff40db349c0699f22dcaf6e">FeedForwardNet</a>(std::string modelPath, std::string modelName, <a class="code hl_enumeration" href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> fileType) : <a class="code hl_class" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelPath, modelName, fileType); };</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a5aa1638cb722f3139dd95f229d0ba0a2">  137</a></span>        <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a5aa1638cb722f3139dd95f229d0ba0a2">FeedForwardNet</a>(std::shared_ptr&lt;AnnData&gt; modelData) : <a class="code hl_class" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a>() { this-&gt;<a class="code hl_function" href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">load_model</a>(modelData); };</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span> </div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a30df96721f1c57e57ed668676f18d9dc">  142</a></span>        <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a30df96721f1c57e57ed668676f18d9dc">~FeedForwardNet</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#aee07aaae68255e370ba1e82c01229cdd">calculate_prediction_reduced_space</a>(<span class="keyword">const</span> std::vector&lt;T&gt; input);</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span> </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a1bbcf42c9cb486f063d8a47722c7a209">calculate_prediction_full_space</a>(<span class="keyword">const</span> std::vector&lt;T&gt; input, <span class="keyword">const</span> std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints);</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a577ee52dca91fe4d987484afa8bf33a8">set_tanh_formulation</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a>&amp; reformulation);</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span> </div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a47ce1749d5969289495ad8a84e438c70">get_number_of_full_space_variables</a>();</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span> </div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a9a6336300c3e798cb58832019e701bc4">get_full_space_variables</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds);</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span> </div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>    };</div>
</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>    <span class="comment">// Set data object containing model parameters</span></div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00196" data-start="{" data-end="}">
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#ae98f7e952148f9d8aa22d2450f50f9db">  196</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#ae98f7e952148f9d8aa22d2450f50f9db">FeedForwardNet&lt;T&gt;::_set_data_object</a>(std::shared_ptr&lt;const ModelData&gt; modelData) {</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>        <span class="comment">// Check if you can downcast the ModelData pointer to an AnnData pointer</span></div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>        _annData = std::dynamic_pointer_cast&lt;const AnnData&gt;(modelData);</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>        <span class="keywordflow">if</span> (_annData == <span class="keyword">nullptr</span>) {</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while loading feed forward network: Incorrect type of passed data object. The data object must be of type AnnData.&quot;</span>));</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>        }</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        _inputScaler = <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">ScalerFactory&lt;T&gt;::create_scaler</a>(_annData-&gt;inputScalerData);</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>        _outputScaler = <a class="code hl_function" href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">ScalerFactory&lt;T&gt;::create_scaler</a>(_annData-&gt;outputScalerData);</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>    }</div>
</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span> </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>    <span class="comment">// Calculates the prediction of the feed forward net for a given point in reduced space mode (only values network inputs are given)</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00211" data-start="{" data-end="}">
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#aee07aaae68255e370ba1e82c01229cdd">  211</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#aee07aaae68255e370ba1e82c01229cdd">FeedForwardNet&lt;T&gt;::calculate_prediction_reduced_space</a>(std::vector&lt;T&gt; input) {</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        std::vector&lt;T&gt; dummyConstraints;</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        std::vector&lt;T&gt; dummyInternalVariables;</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        <span class="keywordflow">try</span> {</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>            <span class="keywordflow">return</span> _calculate_prediction(input, dummyInternalVariables, <span class="keyword">false</span>, dummyConstraints);</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>        }</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating feed forward network. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>        }</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating feed forward network. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        }</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>    }</div>
</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span> </div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>    <span class="comment">// Calculates the prediction of the feed forward net for a given point in full space mode (values for all internal variables are given and a set of constraints is returned)</span></div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00229" data-start="{" data-end="}">
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a1bbcf42c9cb486f063d8a47722c7a209">  229</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a1bbcf42c9cb486f063d8a47722c7a209">FeedForwardNet&lt;T&gt;::calculate_prediction_full_space</a>(<span class="keyword">const</span> std::vector&lt;T&gt; input, <span class="keyword">const</span> std::vector&lt;T&gt; internalVariables, std::vector&lt;T&gt;&amp; constraints) {</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>        <span class="keywordflow">try</span> {</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>            <span class="keywordflow">return</span> _calculate_prediction(input, internalVariables, <span class="keyword">true</span>, constraints);</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        }</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) {</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating feed forward network. Terminating.&quot;</span>, e));</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>        }</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        <span class="keywordflow">catch</span> (...) {</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>            <span class="keywordflow">throw</span>(<a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Encountered a fatal error while evaluating feed forward network. Terminating.&quot;</span>));</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        }</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>    }</div>
</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span> </div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>    <span class="comment">// Changes the reformulation to be used for tanh evaluations.</span></div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00245" data-start="{" data-end="}">
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a577ee52dca91fe4d987484afa8bf33a8">  245</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a577ee52dca91fe4d987484afa8bf33a8">FeedForwardNet&lt;T&gt;::set_tanh_formulation</a>(<span class="keyword">const</span> <a class="code hl_enumeration" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a>&amp; reformulation) {</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <span class="keywordflow">switch</span> (reformulation) {</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06">TANH_REFORMULATION::TANH_REF_0</a>:</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>            this-&gt;_tanh_formulation = &amp;_tanh;</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44">TANH_REFORMULATION::TANH_REF1</a>:</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>            this-&gt;_tanh_formulation = &amp;_tanh_reformulation_1;</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42">TANH_REFORMULATION::TANH_REF2</a>:</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>            this-&gt;_tanh_formulation = &amp;_tanh_reformulation_2;</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e">TANH_REFORMULATION::TANH_REF3</a>:</div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>            this-&gt;_tanh_formulation = &amp;_tanh_reformulation_3;</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0">TANH_REFORMULATION::TANH_REF4</a>:</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>            this-&gt;_tanh_formulation = &amp;_tanh_reformulation_4;</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>        <span class="keywordflow">default</span>:</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while setting tanh formulation: Unknown tanh formulation.&quot;</span>);</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>        }</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>    }</div>
</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span> </div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span> </div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>    <span class="comment">// Get the number of internal network variables</span></div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00271" data-start="{" data-end="}">
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a47ce1749d5969289495ad8a84e438c70">  271</a></span>    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a47ce1749d5969289495ad8a84e438c70">FeedForwardNet&lt;T&gt;::get_number_of_full_space_variables</a>() {</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>        <span class="keywordflow">if</span> (!<a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel&lt;T&gt;::_modelLoaded</a>) {</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error: No network loaded.&quot;</span>);</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        }</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variableNumber;</div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>        std::vector&lt;std::string&gt; dummyVariableNames;</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>        std::vector&lt;std::pair&lt;double, double&gt;&gt; dummyVariableBounds;</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span> </div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>        get_full_space_variables(variableNumber, dummyVariableNames, dummyVariableBounds);</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span> </div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        <span class="keywordflow">return</span> variableNumber;</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>    }</div>
</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span> </div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span> </div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>    <span class="comment">// Returns the number and the names of the internal variables of the network</span></div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00289" data-start="{" data-end="}">
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a9a6336300c3e798cb58832019e701bc4">  289</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a9a6336300c3e798cb58832019e701bc4">FeedForwardNet&lt;T&gt;::get_full_space_variables</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; variableNumber, std::vector&lt;std::string&gt;&amp; variableNames, std::vector&lt;std::pair&lt;double, double&gt;&gt;&amp; variableBounds) {</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>        <span class="keywordflow">if</span> (!<a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel&lt;T&gt;::_modelLoaded</a>) {</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error: No network loaded.&quot;</span>);</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>        }</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span> </div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>        <span class="comment">// Create aliases for data</span></div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>        <span class="keyword">auto</span>&amp; structure = _annData-&gt;structure;</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span>        <span class="keyword">auto</span>&amp; weights = _annData-&gt;weights;</div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span> </div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>        <span class="keyword">const</span> <span class="keywordtype">double</span> MAX_BOUND = 10e6;</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>        variableNumber = 0;</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>        variableNames.clear();</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span>        variableBounds.clear();</div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span> </div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span>        <span class="comment">// Normalized input</span></div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        <span class="keywordflow">if</span> (structure.scaledInput) {</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>            variableNumber += structure.inputSize;</div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; structure.inputSize; i++) {</div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>                variableNames.push_back(<span class="stringliteral">&quot;input_normalized_&quot;</span> + std::to_string(i));</div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span>                variableBounds.push_back(std::make_pair(-1., 1.));</div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span>            }</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>        }</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span> </div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> iLayer = 0; iLayer &lt; structure.numLayers; iLayer++) {</div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span> </div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>            <span class="comment">// Accumulated layer inputs</span></div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span>            variableNumber += structure.layerSize.at(iLayer);</div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> iNeuron = 0; iNeuron &lt; structure.layerSize.at(iLayer); iNeuron++) {</div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>                variableNames.push_back(<span class="stringliteral">&quot;layer_&quot;</span> + std::to_string(iLayer) + <span class="stringliteral">&quot;_neuron_&quot;</span> + std::to_string(iNeuron) + <span class="stringliteral">&quot;_acummulated_input&quot;</span>);</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>                variableBounds.push_back(std::make_pair(-MAX_BOUND, MAX_BOUND));</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>            }</div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span> </div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>            <span class="comment">// Layer outputs</span></div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>            variableNumber += structure.layerSize.at(iLayer);</div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> iNeuron = 0; iNeuron &lt; structure.layerSize.at(iLayer); iNeuron++) {</div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span>                variableNames.push_back(<span class="stringliteral">&quot;layer_&quot;</span> + std::to_string(iLayer) + <span class="stringliteral">&quot;_neuron_&quot;</span> + std::to_string(iNeuron) + <span class="stringliteral">&quot;_output&quot;</span>);</div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>                variableBounds.push_back(std::make_pair(-MAX_BOUND, MAX_BOUND));</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span>            }</div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span>        }</div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>        </div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span>        <span class="comment">// Denormalized ouput</span></div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span>        <span class="keywordflow">if</span> (structure.normalizedOutput) {</div>
<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span>            variableNumber += structure.layerSize.back();</div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; structure.layerSize.back(); i++) {</div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>                variableNames.push_back(<span class="stringliteral">&quot;output_&quot;</span> + std::to_string(i));</div>
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span>                variableBounds.push_back(std::make_pair(-MAX_BOUND, MAX_BOUND));</div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span>            }</div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span>        }</div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span>    }</div>
</div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span> </div>
<div class="line"><a id="l00339" name="l00339"></a><span class="lineno">  339</span> </div>
<div class="line"><a id="l00341" name="l00341"></a><span class="lineno">  341</span>    <span class="comment">// Calculates the prediction of the feed forward net for a given point</span></div>
<div class="line"><a id="l00342" name="l00342"></a><span class="lineno">  342</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00343" data-start="{" data-end="}">
<div class="line"><a id="l00343" name="l00343"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a863db6c1f3e0937db86ecbb59cacf635">  343</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a863db6c1f3e0937db86ecbb59cacf635">FeedForwardNet&lt;T&gt;::_calculate_prediction</a>(<span class="keyword">const</span> std::vector&lt;T&gt; input, <span class="keyword">const</span> std::vector&lt;T&gt; internalVariables, <span class="keyword">const</span> <span class="keywordtype">bool</span> fullSpace, std::vector&lt;T&gt;&amp; constraints) {</div>
<div class="line"><a id="l00344" name="l00344"></a><span class="lineno">  344</span>        <span class="keywordflow">if</span> (<a class="code hl_class" href="classmelon_1_1_melon_model.html">MelonModel&lt;T&gt;::_modelLoaded</a>) {</div>
<div class="line"><a id="l00345" name="l00345"></a><span class="lineno">  345</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00346" name="l00346"></a><span class="lineno">  346</span>            <span class="comment">// 0: Initialization</span></div>
<div class="line"><a id="l00347" name="l00347"></a><span class="lineno">  347</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00348" name="l00348"></a><span class="lineno">  348</span> </div>
<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span>            <span class="comment">// Create aliases for data</span></div>
<div class="line"><a id="l00350" name="l00350"></a><span class="lineno">  350</span>            <span class="keyword">auto</span>&amp; structure = _annData-&gt;structure;</div>
<div class="line"><a id="l00351" name="l00351"></a><span class="lineno">  351</span>            <span class="keyword">auto</span>&amp; weights = _annData-&gt;weights;</div>
<div class="line"><a id="l00352" name="l00352"></a><span class="lineno">  352</span> </div>
<div class="line"><a id="l00353" name="l00353"></a><span class="lineno">  353</span>            <span class="comment">// Check if variables vector has correct size</span></div>
<div class="line"><a id="l00354" name="l00354"></a><span class="lineno">  354</span>            <span class="keywordflow">if</span> (input.size() != structure.inputSize) {</div>
<div class="line"><a id="l00355" name="l00355"></a><span class="lineno">  355</span>                <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while evaluating network: Incorrect number of variables. In reduced space mode evaluation the number of variables must be equal to the number of network inputs.&quot;</span>);</div>
<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span>            }</div>
<div class="line"><a id="l00357" name="l00357"></a><span class="lineno">  357</span>            <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00358" name="l00358"></a><span class="lineno">  358</span>                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variablesSize = get_number_of_full_space_variables();</div>
<div class="line"><a id="l00359" name="l00359"></a><span class="lineno">  359</span>                <span class="keywordflow">if</span> (internalVariables.size() != variablesSize) {</div>
<div class="line"><a id="l00360" name="l00360"></a><span class="lineno">  360</span>                    <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while evaluating network: Incorrect number of variables. In full space mode evaluation the number of variables must be equal to the number of internal network variables.&quot;</span>);</div>
<div class="line"><a id="l00361" name="l00361"></a><span class="lineno">  361</span>                }</div>
<div class="line"><a id="l00362" name="l00362"></a><span class="lineno">  362</span>            }</div>
<div class="line"><a id="l00363" name="l00363"></a><span class="lineno">  363</span> </div>
<div class="line"><a id="l00364" name="l00364"></a><span class="lineno">  364</span>            std::vector&lt;std::vector&lt;T&gt;&gt; networkValues(structure.numLayers);</div>
<div class="line"><a id="l00365" name="l00365"></a><span class="lineno">  365</span> </div>
<div class="line"><a id="l00366" name="l00366"></a><span class="lineno">  366</span>            <span class="keyword">auto</span> variableIterator = internalVariables.begin();</div>
<div class="line"><a id="l00367" name="l00367"></a><span class="lineno">  367</span> </div>
<div class="line"><a id="l00368" name="l00368"></a><span class="lineno">  368</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00369" name="l00369"></a><span class="lineno">  369</span>            <span class="comment">// 1: Normalize the input</span></div>
<div class="line"><a id="l00370" name="l00370"></a><span class="lineno">  370</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00371" name="l00371"></a><span class="lineno">  371</span>            std::vector&lt;T&gt; normalizedInput = input;</div>
<div class="line"><a id="l00372" name="l00372"></a><span class="lineno">  372</span>            <span class="keywordflow">if</span> (structure.scaledInput) {</div>
<div class="line"><a id="l00373" name="l00373"></a><span class="lineno">  373</span>                normalizedInput = _inputScaler-&gt;scale(input);</div>
<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00375" name="l00375"></a><span class="lineno">  375</span>                    this-&gt;_set_constraints(constraints, normalizedInput, variableIterator);</div>
<div class="line"><a id="l00376" name="l00376"></a><span class="lineno">  376</span>                }</div>
<div class="line"><a id="l00377" name="l00377"></a><span class="lineno">  377</span>            }</div>
<div class="line"><a id="l00378" name="l00378"></a><span class="lineno">  378</span> </div>
<div class="line"><a id="l00379" name="l00379"></a><span class="lineno">  379</span> </div>
<div class="line"><a id="l00380" name="l00380"></a><span class="lineno">  380</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span>            <span class="comment">// 2: Evaluate each layer in the network</span></div>
<div class="line"><a id="l00382" name="l00382"></a><span class="lineno">  382</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span>            <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> iLayer = 0; iLayer &lt; networkValues.size(); iLayer++) {</div>
<div class="line"><a id="l00384" name="l00384"></a><span class="lineno">  384</span> </div>
<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span>                <span class="comment">// Create aliases for better code readability</span></div>
<div class="line"><a id="l00386" name="l00386"></a><span class="lineno">  386</span>                <span class="keyword">auto</span>&amp; layerInputWeights = weights.inputWeight.at(iLayer);</div>
<div class="line"><a id="l00387" name="l00387"></a><span class="lineno">  387</span>                <span class="keyword">auto</span>&amp; layerBiasWeights = weights.biasWeight.at(iLayer);</div>
<div class="line"><a id="l00388" name="l00388"></a><span class="lineno">  388</span>                <span class="keyword">auto</span>&amp; layerIncidentLayerWeights = weights.layerWeight.at(iLayer);</div>
<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span>                <span class="keyword">auto</span>&amp; layerConnections = structure.layerConnect.at(iLayer);</div>
<div class="line"><a id="l00390" name="l00390"></a><span class="lineno">  390</span>                <span class="keyword">auto</span>&amp; layerSize = structure.layerSize.at(iLayer);</div>
<div class="line"><a id="l00391" name="l00391"></a><span class="lineno">  391</span> </div>
<div class="line"><a id="l00392" name="l00392"></a><span class="lineno">  392</span>                <span class="comment">// 1a Calculate weighted sum</span></div>
<div class="line"><a id="l00393" name="l00393"></a><span class="lineno">  393</span>                std::vector&lt;T&gt; accumulatedLayerInputs(structure.layerSize.at(iLayer), 0);</div>
<div class="line"><a id="l00394" name="l00394"></a><span class="lineno">  394</span> </div>
<div class="line"><a id="l00395" name="l00395"></a><span class="lineno">  395</span>                <span class="comment">// - input variables incident to the current layer</span></div>
<div class="line"><a id="l00396" name="l00396"></a><span class="lineno">  396</span>                <span class="keywordflow">if</span> (structure.inputConnect.at(iLayer) == 1) {</div>
<div class="line"><a id="l00397" name="l00397"></a><span class="lineno">  397</span>                    accumulatedLayerInputs = accumulatedLayerInputs + layerInputWeights * normalizedInput;</div>
<div class="line"><a id="l00398" name="l00398"></a><span class="lineno">  398</span>                }</div>
<div class="line"><a id="l00399" name="l00399"></a><span class="lineno">  399</span> </div>
<div class="line"><a id="l00400" name="l00400"></a><span class="lineno">  400</span>                <span class="comment">// - bias for the current layer</span></div>
<div class="line"><a id="l00401" name="l00401"></a><span class="lineno">  401</span>                <span class="keywordflow">if</span> (structure.biasConnect.at(iLayer) == 1) {</div>
<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span>                    accumulatedLayerInputs = accumulatedLayerInputs + layerBiasWeights;</div>
<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span>                }</div>
<div class="line"><a id="l00404" name="l00404"></a><span class="lineno">  404</span> </div>
<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span>                <span class="comment">// - values from previous layers that are incident to the current layer</span></div>
<div class="line"><a id="l00406" name="l00406"></a><span class="lineno">  406</span>                <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> iIncidentLayer = 0; iIncidentLayer &lt; layerConnections.size(); iIncidentLayer++) {</div>
<div class="line"><a id="l00407" name="l00407"></a><span class="lineno">  407</span>                    <span class="keywordflow">if</span> (layerConnections.at(iIncidentLayer) == 1) {</div>
<div class="line"><a id="l00408" name="l00408"></a><span class="lineno">  408</span>                        accumulatedLayerInputs = accumulatedLayerInputs + layerIncidentLayerWeights.at(iIncidentLayer)*networkValues.at(iIncidentLayer);</div>
<div class="line"><a id="l00409" name="l00409"></a><span class="lineno">  409</span>                    }</div>
<div class="line"><a id="l00410" name="l00410"></a><span class="lineno">  410</span>                }</div>
<div class="line"><a id="l00411" name="l00411"></a><span class="lineno">  411</span> </div>
<div class="line"><a id="l00412" name="l00412"></a><span class="lineno">  412</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00413" name="l00413"></a><span class="lineno">  413</span>                    this-&gt;_set_constraints(constraints, accumulatedLayerInputs, variableIterator);</div>
<div class="line"><a id="l00414" name="l00414"></a><span class="lineno">  414</span>                }</div>
<div class="line"><a id="l00415" name="l00415"></a><span class="lineno">  415</span> </div>
<div class="line"><a id="l00416" name="l00416"></a><span class="lineno">  416</span>                <span class="comment">// 2b Calculate the layer output by evaluating the activation function on the weighted sum </span></div>
<div class="line"><a id="l00417" name="l00417"></a><span class="lineno">  417</span>                std::vector&lt;T&gt; layerOutput = _calculate_layer_activation(accumulatedLayerInputs, structure.activationFunction.at(iLayer));</div>
<div class="line"><a id="l00418" name="l00418"></a><span class="lineno">  418</span> </div>
<div class="line"><a id="l00419" name="l00419"></a><span class="lineno">  419</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00420" name="l00420"></a><span class="lineno">  420</span>                    this-&gt;_set_constraints(constraints, layerOutput, variableIterator);</div>
<div class="line"><a id="l00421" name="l00421"></a><span class="lineno">  421</span>                }</div>
<div class="line"><a id="l00422" name="l00422"></a><span class="lineno">  422</span> </div>
<div class="line"><a id="l00423" name="l00423"></a><span class="lineno">  423</span>                networkValues.at(iLayer) = layerOutput;</div>
<div class="line"><a id="l00424" name="l00424"></a><span class="lineno">  424</span>            }</div>
<div class="line"><a id="l00425" name="l00425"></a><span class="lineno">  425</span> </div>
<div class="line"><a id="l00426" name="l00426"></a><span class="lineno">  426</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00427" name="l00427"></a><span class="lineno">  427</span>            <span class="comment">// 2: Denormalize network output</span></div>
<div class="line"><a id="l00428" name="l00428"></a><span class="lineno">  428</span>            <span class="comment">// ---------------------------------------------------------------------------------</span></div>
<div class="line"><a id="l00429" name="l00429"></a><span class="lineno">  429</span>            std::vector&lt;T&gt; output = networkValues.back();</div>
<div class="line"><a id="l00430" name="l00430"></a><span class="lineno">  430</span>            <span class="keywordflow">if</span> (structure.normalizedOutput) {</div>
<div class="line"><a id="l00431" name="l00431"></a><span class="lineno">  431</span>                output = _outputScaler-&gt;descale(networkValues.back());</div>
<div class="line"><a id="l00432" name="l00432"></a><span class="lineno">  432</span>                <span class="keywordflow">if</span> (fullSpace) {</div>
<div class="line"><a id="l00433" name="l00433"></a><span class="lineno">  433</span>                    this-&gt;_set_constraints(constraints, output, variableIterator);</div>
<div class="line"><a id="l00434" name="l00434"></a><span class="lineno">  434</span>                }</div>
<div class="line"><a id="l00435" name="l00435"></a><span class="lineno">  435</span>            }</div>
<div class="line"><a id="l00436" name="l00436"></a><span class="lineno">  436</span> </div>
<div class="line"><a id="l00437" name="l00437"></a><span class="lineno">  437</span>            <span class="keywordflow">return</span> output;</div>
<div class="line"><a id="l00438" name="l00438"></a><span class="lineno">  438</span>        }</div>
<div class="line"><a id="l00439" name="l00439"></a><span class="lineno">  439</span>        <span class="keywordflow">else</span> {</div>
<div class="line"><a id="l00440" name="l00440"></a><span class="lineno">  440</span>            <span class="keywordflow">throw</span> <a class="code hl_class" href="class_melon_exception.html">MelonException</a>(<span class="stringliteral">&quot;  Error while evaluating network: No network loaded.&quot;</span>);</div>
<div class="line"><a id="l00441" name="l00441"></a><span class="lineno">  441</span>        }</div>
<div class="line"><a id="l00442" name="l00442"></a><span class="lineno">  442</span>    };</div>
</div>
<div class="line"><a id="l00443" name="l00443"></a><span class="lineno">  443</span> </div>
<div class="line"><a id="l00444" name="l00444"></a><span class="lineno">  444</span> </div>
<div class="line"><a id="l00446" name="l00446"></a><span class="lineno">  446</span>    <span class="comment">// Calculates the activations for a layer given its inputs.</span></div>
<div class="line"><a id="l00447" name="l00447"></a><span class="lineno">  447</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00448" data-start="{" data-end="}">
<div class="line"><a id="l00448" name="l00448"></a><span class="lineno"><a class="line" href="classmelon_1_1_feed_forward_net.html#a52bc8b4239937c6290e3a2b59dad9f24">  448</a></span>    std::vector&lt;T&gt; <a class="code hl_function" href="classmelon_1_1_feed_forward_net.html#a52bc8b4239937c6290e3a2b59dad9f24">FeedForwardNet&lt;T&gt;::_calculate_layer_activation</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v, <span class="keyword">const</span> <a class="code hl_enumeration" href="namespacemelon.html#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a> activationFunction) {</div>
<div class="line"><a id="l00449" name="l00449"></a><span class="lineno">  449</span> </div>
<div class="line"><a id="l00450" name="l00450"></a><span class="lineno">  450</span>        std::vector&lt;T&gt; layerActivation(v);</div>
<div class="line"><a id="l00451" name="l00451"></a><span class="lineno">  451</span> </div>
<div class="line"><a id="l00452" name="l00452"></a><span class="lineno">  452</span>        <span class="comment">// Select correct activation function</span></div>
<div class="line"><a id="l00453" name="l00453"></a><span class="lineno">  453</span>        T(*activation_function) (T);</div>
<div class="line"><a id="l00454" name="l00454"></a><span class="lineno">  454</span>        <span class="keywordflow">switch</span> (activationFunction) {</div>
<div class="line"><a id="l00455" name="l00455"></a><span class="lineno">  455</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b">ACTIVATION_FUNCTION::PURE_LIN</a>:</div>
<div class="line"><a id="l00456" name="l00456"></a><span class="lineno">  456</span>            <span class="keywordflow">return</span> layerActivation;</div>
<div class="line"><a id="l00457" name="l00457"></a><span class="lineno">  457</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2">ACTIVATION_FUNCTION::TANH</a>:</div>
<div class="line"><a id="l00458" name="l00458"></a><span class="lineno">  458</span>            activation_function = this-&gt;_tanh_formulation;</div>
<div class="line"><a id="l00459" name="l00459"></a><span class="lineno">  459</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00460" name="l00460"></a><span class="lineno">  460</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c">ACTIVATION_FUNCTION::RELU</a>:</div>
<div class="line"><a id="l00461" name="l00461"></a><span class="lineno">  461</span>            activation_function = &amp;_relu;</div>
<div class="line"><a id="l00462" name="l00462"></a><span class="lineno">  462</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00463" name="l00463"></a><span class="lineno">  463</span>        <span class="keywordflow">case</span> <a class="code hl_enumvalue" href="namespacemelon.html#a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed">ACTIVATION_FUNCTION::RELU6</a>:</div>
<div class="line"><a id="l00464" name="l00464"></a><span class="lineno">  464</span>            activation_function = &amp;_relu6;</div>
<div class="line"><a id="l00465" name="l00465"></a><span class="lineno">  465</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00466" name="l00466"></a><span class="lineno">  466</span>        }</div>
<div class="line"><a id="l00467" name="l00467"></a><span class="lineno">  467</span> </div>
<div class="line"><a id="l00468" name="l00468"></a><span class="lineno">  468</span>        <span class="comment">//  Apply activation function to all entries in v (layer neurons) and write the results to layerActivation</span></div>
<div class="line"><a id="l00469" name="l00469"></a><span class="lineno">  469</span>        std::transform(v.begin(), v.end(), layerActivation.begin(), activation_function);</div>
<div class="line"><a id="l00470" name="l00470"></a><span class="lineno">  470</span> </div>
<div class="line"><a id="l00471" name="l00471"></a><span class="lineno">  471</span>        <span class="keywordflow">return</span> layerActivation;</div>
<div class="line"><a id="l00472" name="l00472"></a><span class="lineno">  472</span>    };</div>
</div>
<div class="line"><a id="l00473" name="l00473"></a><span class="lineno">  473</span>}</div>
<div class="ttc" id="a_ann_parser_8h_html"><div class="ttname"><a href="_ann_parser_8h.html">AnnParser.h</a></div></div>
<div class="ttc" id="a_ann_properties_8h_html"><div class="ttname"><a href="_ann_properties_8h.html">AnnProperties.h</a></div></div>
<div class="ttc" id="a_me_l_on_8h_html"><div class="ttname"><a href="_me_l_on_8h.html">MeLOn.h</a></div></div>
<div class="ttc" id="aclass_melon_exception_html"><div class="ttname"><a href="class_melon_exception.html">MelonException</a></div><div class="ttdoc">This class defines the exceptions thrown by FeedForwardNet.</div><div class="ttdef"><b>Definition</b> exceptions.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_ann_parser_factory_html"><div class="ttname"><a href="classmelon_1_1_ann_parser_factory.html">melon::AnnParserFactory</a></div><div class="ttdoc">This class is a factory class for creating child instances of AnnParser.</div><div class="ttdef"><b>Definition</b> AnnParser.h:215</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html">melon::FeedForwardNet</a></div><div class="ttdoc">This class represents a feed foward artificial network to be used in the MAiNGO solver.</div><div class="ttdef"><b>Definition</b> ffNet.h:52</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a1bbcf42c9cb486f063d8a47722c7a209"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a1bbcf42c9cb486f063d8a47722c7a209">melon::FeedForwardNet::calculate_prediction_full_space</a></div><div class="ttdeci">std::vector&lt; T &gt; calculate_prediction_full_space(const std::vector&lt; T &gt; input, const std::vector&lt; T &gt; internalVariables, std::vector&lt; T &gt; &amp;constraints)</div><div class="ttdoc">Calculates the prediction of the feed forward net for a given point in full space mode (values for al...</div><div class="ttdef"><b>Definition</b> ffNet.h:229</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a25f7c656e140792b73fccc7058249256"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a25f7c656e140792b73fccc7058249256">melon::FeedForwardNet::_outputScaler</a></div><div class="ttdeci">std::unique_ptr&lt; Scaler&lt; T &gt; &gt; _outputScaler</div><div class="ttdef"><b>Definition</b> ffNet.h:58</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a30df96721f1c57e57ed668676f18d9dc"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a30df96721f1c57e57ed668676f18d9dc">melon::FeedForwardNet::~FeedForwardNet</a></div><div class="ttdeci">~FeedForwardNet()=default</div><div class="ttdoc">Default Destructor.</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a3b6e46ca8afad6af62b3f15e2b6b5ec6"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a3b6e46ca8afad6af62b3f15e2b6b5ec6">melon::FeedForwardNet::_annData</a></div><div class="ttdeci">std::shared_ptr&lt; const AnnData &gt; _annData</div><div class="ttdef"><b>Definition</b> ffNet.h:55</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a40d5999e0803420f02e2285aee4d7f19"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a40d5999e0803420f02e2285aee4d7f19">melon::FeedForwardNet::FeedForwardNet</a></div><div class="ttdeci">FeedForwardNet()</div><div class="ttdoc">Constructor for creating object with no model loaded.</div><div class="ttdef"><b>Definition</b> ffNet.h:110</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a47ce1749d5969289495ad8a84e438c70"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a47ce1749d5969289495ad8a84e438c70">melon::FeedForwardNet::get_number_of_full_space_variables</a></div><div class="ttdeci">unsigned int get_number_of_full_space_variables()</div><div class="ttdoc">Get the number of internal network variables.</div><div class="ttdef"><b>Definition</b> ffNet.h:271</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a52bc8b4239937c6290e3a2b59dad9f24"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a52bc8b4239937c6290e3a2b59dad9f24">melon::FeedForwardNet::_calculate_layer_activation</a></div><div class="ttdeci">std::vector&lt; T &gt; _calculate_layer_activation(const std::vector&lt; T &gt; &amp;v, const ACTIVATION_FUNCTION activationFunction)</div><div class="ttdoc">Calculates the activations for a layer given its inputs.</div><div class="ttdef"><b>Definition</b> ffNet.h:448</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a577ee52dca91fe4d987484afa8bf33a8"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a577ee52dca91fe4d987484afa8bf33a8">melon::FeedForwardNet::set_tanh_formulation</a></div><div class="ttdeci">void set_tanh_formulation(const TANH_REFORMULATION &amp;reformulation)</div><div class="ttdoc">Changes the reformulation to be used for tanh evaluations. The reformulations are intended to be used...</div><div class="ttdef"><b>Definition</b> ffNet.h:245</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a5aa1638cb722f3139dd95f229d0ba0a2"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a5aa1638cb722f3139dd95f229d0ba0a2">melon::FeedForwardNet::FeedForwardNet</a></div><div class="ttdeci">FeedForwardNet(std::shared_ptr&lt; AnnData &gt; modelData)</div><div class="ttdoc">Constructor for creating object from existing AnnData object.</div><div class="ttdef"><b>Definition</b> ffNet.h:137</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a81e55a0f8f437563f86d3e896c1db9c0"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a81e55a0f8f437563f86d3e896c1db9c0">melon::FeedForwardNet::_relu</a></div><div class="ttdeci">static T _relu(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:68</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a863db6c1f3e0937db86ecbb59cacf635"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a863db6c1f3e0937db86ecbb59cacf635">melon::FeedForwardNet::_calculate_prediction</a></div><div class="ttdeci">std::vector&lt; T &gt; _calculate_prediction(const std::vector&lt; T &gt; input, const std::vector&lt; T &gt; internalVariables, const bool fullSpace, std::vector&lt; T &gt; &amp;constraints)</div><div class="ttdoc">Calculates the prediction of the feed forward net for a given point.</div><div class="ttdef"><b>Definition</b> ffNet.h:343</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a8d22eb1e65b7f74b4e84c3c8ea78df51"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a8d22eb1e65b7f74b4e84c3c8ea78df51">melon::FeedForwardNet::_inputScaler</a></div><div class="ttdeci">std::unique_ptr&lt; Scaler&lt; T &gt; &gt; _inputScaler</div><div class="ttdef"><b>Definition</b> ffNet.h:57</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_a9a6336300c3e798cb58832019e701bc4"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#a9a6336300c3e798cb58832019e701bc4">melon::FeedForwardNet::get_full_space_variables</a></div><div class="ttdeci">void get_full_space_variables(unsigned int &amp;variableNumber, std::vector&lt; std::string &gt; &amp;variableNames, std::vector&lt; std::pair&lt; double, double &gt; &gt; &amp;variableBounds)</div><div class="ttdoc">Returns the number and the names of the internal variables of the network.</div><div class="ttdef"><b>Definition</b> ffNet.h:289</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_aa135bf5d528c1b99a63f0cf3ddceb7ac"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#aa135bf5d528c1b99a63f0cf3ddceb7ac">melon::FeedForwardNet::_tanh_reformulation_3</a></div><div class="ttdeci">static T _tanh_reformulation_3(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:65</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_aa29c58f20ab3b344243565940fc0e243"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#aa29c58f20ab3b344243565940fc0e243">melon::FeedForwardNet::_tanh_formulation</a></div><div class="ttdeci">T(* _tanh_formulation)(T)</div><div class="ttdef"><b>Definition</b> ffNet.h:61</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_aa5bfb8592ff40db349c0699f22dcaf6e"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#aa5bfb8592ff40db349c0699f22dcaf6e">melon::FeedForwardNet::FeedForwardNet</a></div><div class="ttdeci">FeedForwardNet(std::string modelPath, std::string modelName, MODEL_FILE_TYPE fileType)</div><div class="ttdoc">Constructor for creating object from file with the modelName being relative to modelPath.</div><div class="ttdef"><b>Definition</b> ffNet.h:130</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_aa827bc95b61702119170c403edb86f9c"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#aa827bc95b61702119170c403edb86f9c">melon::FeedForwardNet::_tanh_reformulation_1</a></div><div class="ttdeci">static T _tanh_reformulation_1(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:63</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_ab7ba2a702f03f392778f7d05a43ce356"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#ab7ba2a702f03f392778f7d05a43ce356">melon::FeedForwardNet::_relu6</a></div><div class="ttdeci">static T _relu6(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:69</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_ac1ac26b7d389470fc0a13463cddd9a3f"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#ac1ac26b7d389470fc0a13463cddd9a3f">melon::FeedForwardNet::FeedForwardNet</a></div><div class="ttdeci">FeedForwardNet(std::string modelName, MODEL_FILE_TYPE fileType)</div><div class="ttdoc">Constructor for creating object from file with the modelName relative to the current working director...</div><div class="ttdef"><b>Definition</b> ffNet.h:119</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_ac33420287de3773a2ab4dfab022287cf"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#ac33420287de3773a2ab4dfab022287cf">melon::FeedForwardNet::_tanh_reformulation_4</a></div><div class="ttdeci">static T _tanh_reformulation_4(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:66</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_acc52bba26e3affaf5bd8bdd97367130f"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#acc52bba26e3affaf5bd8bdd97367130f">melon::FeedForwardNet::_tanh</a></div><div class="ttdeci">static T _tanh(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:62</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_ae98f7e952148f9d8aa22d2450f50f9db"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#ae98f7e952148f9d8aa22d2450f50f9db">melon::FeedForwardNet::_set_data_object</a></div><div class="ttdeci">void _set_data_object(std::shared_ptr&lt; const ModelData &gt; modelData) override</div><div class="ttdoc">Sets data object containing model parameters.</div><div class="ttdef"><b>Definition</b> ffNet.h:196</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_aee07aaae68255e370ba1e82c01229cdd"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#aee07aaae68255e370ba1e82c01229cdd">melon::FeedForwardNet::calculate_prediction_reduced_space</a></div><div class="ttdeci">std::vector&lt; T &gt; calculate_prediction_reduced_space(const std::vector&lt; T &gt; input)</div><div class="ttdoc">Calculates the prediction of the feed forward net for a given point in reduced space mode (only value...</div><div class="ttdef"><b>Definition</b> ffNet.h:211</div></div>
<div class="ttc" id="aclassmelon_1_1_feed_forward_net_html_af2ce30b35e0450243cdcc4f77649b9a7"><div class="ttname"><a href="classmelon_1_1_feed_forward_net.html#af2ce30b35e0450243cdcc4f77649b9a7">melon::FeedForwardNet::_tanh_reformulation_2</a></div><div class="ttdeci">static T _tanh_reformulation_2(T x)</div><div class="ttdef"><b>Definition</b> ffNet.h:64</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html"><div class="ttname"><a href="classmelon_1_1_melon_model.html">melon::MelonModel</a></div><div class="ttdef"><b>Definition</b> MeLOn.h:32</div></div>
<div class="ttc" id="aclassmelon_1_1_melon_model_html_a9acb78ea183bc6bf583540efcef58a0b"><div class="ttname"><a href="classmelon_1_1_melon_model.html#a9acb78ea183bc6bf583540efcef58a0b">melon::MelonModel::load_model</a></div><div class="ttdeci">void load_model(std::string modelName, MODEL_FILE_TYPE fileType)</div><div class="ttdoc">Loads new model from file.</div><div class="ttdef"><b>Definition</b> MeLOn.h:114</div></div>
<div class="ttc" id="aclassmelon_1_1_scaler_factory_html_a269bf924a7c0cbafe35d32857655cb9c"><div class="ttname"><a href="classmelon_1_1_scaler_factory.html#a269bf924a7c0cbafe35d32857655cb9c">melon::ScalerFactory::create_scaler</a></div><div class="ttdeci">static std::unique_ptr&lt; Scaler&lt; T &gt; &gt; create_scaler(const std::shared_ptr&lt; const ScalerData &gt; scalerData)</div><div class="ttdoc">Factory function for creating a instance of a scaler object.</div><div class="ttdef"><b>Definition</b> scaler.h:208</div></div>
<div class="ttc" id="aexceptions_8h_html"><div class="ttname"><a href="exceptions_8h.html">exceptions.h</a></div></div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="anamespacemelon_html_a4304be33fc99f22bd328db5774394531"><div class="ttname"><a href="namespacemelon.html#a4304be33fc99f22bd328db5774394531">melon::MODEL_FILE_TYPE</a></div><div class="ttdeci">MODEL_FILE_TYPE</div><div class="ttdoc">Enum for representing the parsable filetypes.</div><div class="ttdef"><b>Definition</b> modelParser.h:30</div></div>
<div class="ttc" id="anamespacemelon_html_a48f12885945641a41597e6668940dc73"><div class="ttname"><a href="namespacemelon.html#a48f12885945641a41597e6668940dc73">melon::ACTIVATION_FUNCTION</a></div><div class="ttdeci">ACTIVATION_FUNCTION</div><div class="ttdoc">Enum for representing the available types of scaler parameters.</div><div class="ttdef"><b>Definition</b> AnnProperties.h:30</div></div>
<div class="ttc" id="anamespacemelon_html_a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b"><div class="ttname"><a href="namespacemelon.html#a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b">melon::PURE_LIN</a></div><div class="ttdeci">@ PURE_LIN</div><div class="ttdef"><b>Definition</b> AnnProperties.h:31</div></div>
<div class="ttc" id="anamespacemelon_html_a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed"><div class="ttname"><a href="namespacemelon.html#a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed">melon::RELU6</a></div><div class="ttdeci">@ RELU6</div><div class="ttdef"><b>Definition</b> AnnProperties.h:34</div></div>
<div class="ttc" id="anamespacemelon_html_a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c"><div class="ttname"><a href="namespacemelon.html#a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c">melon::RELU</a></div><div class="ttdeci">@ RELU</div><div class="ttdef"><b>Definition</b> AnnProperties.h:33</div></div>
<div class="ttc" id="anamespacemelon_html_a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2"><div class="ttname"><a href="namespacemelon.html#a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2">melon::TANH</a></div><div class="ttdeci">@ TANH</div><div class="ttdef"><b>Definition</b> AnnProperties.h:32</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45">melon::TANH_REFORMULATION</a></div><div class="ttdeci">TANH_REFORMULATION</div><div class="ttdoc">Enum for representing the different reformulations for the tanh activation function.</div><div class="ttdef"><b>Definition</b> ffNet.h:37</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06">melon::TANH_REF_0</a></div><div class="ttdeci">@ TANH_REF_0</div><div class="ttdef"><b>Definition</b> ffNet.h:38</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0">melon::TANH_REF4</a></div><div class="ttdeci">@ TANH_REF4</div><div class="ttdef"><b>Definition</b> ffNet.h:42</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44">melon::TANH_REF1</a></div><div class="ttdeci">@ TANH_REF1</div><div class="ttdef"><b>Definition</b> ffNet.h:39</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e">melon::TANH_REF3</a></div><div class="ttdeci">@ TANH_REF3</div><div class="ttdef"><b>Definition</b> ffNet.h:41</div></div>
<div class="ttc" id="anamespacemelon_html_a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42"><div class="ttname"><a href="namespacemelon.html#a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42">melon::TANH_REF2</a></div><div class="ttdeci">@ TANH_REF2</div><div class="ttdef"><b>Definition</b> ffNet.h:40</div></div>
<div class="ttc" id="avectorarithmetics_8h_html"><div class="ttname"><a href="vectorarithmetics_8h.html">vectorarithmetics.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_2153465d1994426effb356c466256250.html">feedforward neural network</a></li><li class="navelem"><a class="el" href="dir_81c62c849c41b038c690bb0249c57a89.html">model</a></li><li class="navelem"><a class="el" href="dir_0483e226728de3cf46b78d7534efffda.html">inc</a></li><li class="navelem"><a class="el" href="ff_net_8h.html">ffNet.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
